package labyrinth.game;

import java.io.IOException;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import labyrinth.menu.LabyrinthMenu;
import labyrinth.menu.RecordsScreen;
import labyrinth.records.RecordRegistry;
import labyrinth.settings.SoundNokia;
import labyrinth.settings.constants.LabyrinthConstants1;
import labyrinth.settings.constants.LabyrinthConstants2;
import labyrinth.settings.constants.LabyrinthConstants3;

import com.nokia.mid.ui.FullCanvas;

public class GameScreen extends FullCanvas{// implements Runnable {

	private LabyrinthMenu main;

	private Game game;

	private Image sprite;

	private Image background;

	private Image fase;

	private Image clock;

	private int x;

	private int y;

	private int xOld;

	private int yOld;

	private Timer t;

	private Counter c;

	private boolean informations;

	private Image key;

	SoundNokia sound = new SoundNokia();

	private boolean apagou = true;

	private boolean end;

	private boolean win;
	
	private boolean withKey;

	//private Graphics grap;

	public GameScreen(LabyrinthMenu main) {

		try {
			this.main = main;

			this.main.getMain().setGameScreen(this);

			//main.getMain().setGameScreen(this);

			//Inicializando a classe Game responsvel pela lgica(controle) do
			// jogo.
			this.game = new Game(this.getInitialLabyrinth());

			this.x = game.getXPosition() * 4;
			this.y = game.getYPosition() * 4;

			//Inicializando as figuras do sprite e do labirinto
			//sprite = null;
			this.sprite = Image.createImage("/labyrinth/images/sprite.png");

			background = Image.createImage(this.game.getLabyrinth());
			clock = null;
			fase = null;
			
			//inicializa o contador
			this.game.setTime(this.game.getTime() + 3);
			this.initializeCount();
			withKey = false;
			informations = true;
			end = false;
			win = false;
			
			//testDecTimer();

			Timer t = new Timer();

			//Pintando a tela
			PaintTimerTask pt = new PaintTimerTask();
			t.schedule(pt, 2500);

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public GameScreen(LabyrinthMenu main, Game g) {

		try {
			this.main = main;

			this.main.getMain().setGameScreen(this);

			//main.getMain().setGameScreen(this);

			//Inicializando a classe Game responsvel pela lgica(controle) do
			// jogo.
			this.game = g;

			this.x = game.getXPosition() * 4;
			this.y = game.getYPosition() * 4;

			if (this.game.isScreen2()) {
				this.x = this.x - 128;
			}

			//Inicializando as figuras do sprite e do labirinto
			//sprite = null;
			this.sprite = Image.createImage("/labyrinth/images/sprite.png");

			background = Image.createImage(this.game.getLabyrinth());
			clock = null;
			fase = null;

			//inicializa o contador
			this.game.setTime(this.game.getTime() + 3);
			this.initializeCount();
			withKey = false;
			informations = true;
			end = false;
			win = false;

			Timer t = new Timer();
			//Pintando a tela
			PaintTimerTask pt = new PaintTimerTask();
			t.schedule(pt, 2500);
		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	/***************************************************************************
	 * O mtodo paint(Graphics graphics) pinta a tela no visor do aparelho
	 **************************************************************************/
	protected void paint(Graphics graphics) {

		try {

			if (!apagou) {
				graphics.setColor(0, 0, 0);
				graphics.fillRect(this.xOld, this.yOld, 8, 8);
			} else if (apagou && !informations) {

				graphics.setColor(0, 0, 0);
				graphics.fillRect(this.xOld, this.yOld, 8, 8);

				/*
				 * graphics.drawImage(this.black, this.xOld, this.yOld,
				 * Graphics.LEFT | Graphics.TOP);
				 */

				//Labirinto
				if (this.background != null) {
					graphics.setColor(85, 81, 82);

					if (!this.game.isScreen2()) {
						graphics.drawImage(this.background, 0, 0, Graphics.LEFT
								| Graphics.TOP);
					} else {
						graphics.drawImage(this.background, -128, 0,
								Graphics.LEFT | Graphics.TOP);
					}
					this.clock = Image
							.createImage("/labyrinth/images/relogio12.png");
					graphics.drawImage(this.clock, 90, 2, Graphics.LEFT
							| Graphics.TOP);

					int a = this.game.getKeyX() * 4;
					int b = this.game.getKeyY() * 4;
					this.key = Image.createImage("/labyrinth/images/key.png");
					if (this.game.isFindKey()) {
						graphics.drawImage(this.key, (this.getWidth() / 2) + 6,
								9, Graphics.HCENTER | Graphics.VCENTER);
					} else {
						if (a >= 128 && this.game.isScreen2()) {
							graphics.drawImage(this.key, a - 128, b,
									Graphics.LEFT | Graphics.TOP);
						} else if (a < 128 && !this.game.isScreen2()) {

							graphics.drawImage(this.key, a, b, Graphics.LEFT
									| Graphics.TOP);
						}
					}

					this.key = null;
					this.clock = null;
					this.background = null;
					Runtime.getRuntime().gc();
				}

				if (this.game.colisionKey()) {
					if (!withKey){						
					SoundNokia sound = new SoundNokia(1175, 10);
					sound.run();
					sound = new SoundNokia(2217, 20);
					sound.run();
					withKey = true;
					}
					int a = this.game.getKeyX() * 4;
					int b = this.game.getKeyY() * 4;
					graphics.setColor(0, 0, 0);
					this.key = Image.createImage("/labyrinth/images/key.png");
					if (a >= 128 && this.game.isScreen2()) {
						graphics.fillRect(a - 128, b, 16, 8);
					} else if (a < 128 && !this.game.isScreen2()) {
						graphics.fillRect(a, b, 16, 8);
					}

					graphics.drawImage(this.key, (this.getWidth() / 2) + 6, 9,
							Graphics.HCENTER | Graphics.VCENTER);

					this.key = null;
					System.gc();
				}				
				//graphics.setColor(0, 0, 0);
				//graphics.fillRect(this.xOld, this.yOld, 8, 8);
				graphics.drawImage(this.sprite, this.x, this.y, Graphics.LEFT
						| Graphics.TOP);

				//	Vidas
				graphics.setColor(100, 226, 228);
				graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
						Font.STYLE_PLAIN, Font.SIZE_SMALL));
				graphics.drawString("Lives: ", 2, 4, Graphics.LEFT
						| Graphics.TOP);

				int lives = this.game.getLives();
				for (int i = 1; i <= lives; i++) {
					graphics.drawImage(this.sprite, (i * 11) + 25, 4,
							Graphics.LEFT | Graphics.TOP);
				}

				//	pintar o tempo
				graphics.setColor(0, 0, 0);

				graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
						Font.STYLE_PLAIN, Font.SIZE_SMALL));
				graphics.fillRect(105, 4, graphics.getFont().getHeight() * 3,
						graphics.getFont().getHeight());
				graphics.setColor(100, 226, 228);
				graphics.drawString("" + this.game.getTime(), 105, 4,
						Graphics.LEFT | Graphics.TOP);

			} else {
				this.fase = Image.createImage("/labyrinth/images/fase.png");
				graphics.setColor(255, 255, 255);
				graphics.fillRect(0, 0, getWidth(), getHeight());
				graphics.drawImage(this.fase, 0, 0, Graphics.LEFT
						| Graphics.TOP);
				graphics.setColor(255, 255, 255);

				if (!end) {

					graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
							Font.STYLE_PLAIN, Font.SIZE_LARGE));
					graphics.drawString("Level " + this.game.getStage(), this
							.getWidth() / 2, this.getHeight() / 2 - 24,
							Graphics.BASELINE | Graphics.HCENTER);
					graphics.drawString("Score " + this.game.getScore(), this
							.getWidth() / 2, this.getHeight() / 2 + 10,
							Graphics.BASELINE | Graphics.HCENTER);

					this.fase = null;
					System.gc();
				} else {

					if (win) {
						graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
								Font.STYLE_PLAIN, Font.SIZE_LARGE));
						graphics.drawString("You won!!", this.getWidth() / 2,
								this.getHeight() / 2 - 24, Graphics.BASELINE
										| Graphics.HCENTER);
						graphics.drawString("Score " + this.game.getScore(),
								this.getWidth() / 2, this.getHeight() / 2 + 10,
								Graphics.BASELINE | Graphics.HCENTER);
					} else {
						graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
								Font.STYLE_PLAIN, Font.SIZE_LARGE));
						graphics.drawString("GAME OVER", this.getWidth() / 2,
								this.getHeight() / 2 - 24, Graphics.BASELINE
										| Graphics.HCENTER);
						graphics.drawString("Try again!", this.getWidth() / 2,
								this.getHeight() / 2 + 10, Graphics.BASELINE
										| Graphics.HCENTER);
					}

					this.fase = null;
					System.gc();

				}
			}

		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	public void keyReleased(int key) {
		int action = getGameAction(key);
		if (key == KEY_SOFTKEY2) {
			this.saveGame();
			repaint();
		} else if (action == KEY_END) {
			this.saveGame();
			repaint();
		}
	}

	/***************************************************************************
	 * O mtodo keyPressed(int keycode) verifica a acao referente a tecla
	 * pressionada.
	 **************************************************************************/

	public void keyPressed(int key) {
		int action = getGameAction(key);
		if (!end){
		//if (repaint) {
		//this.repaint = false;
		this.apagou = false;
		this.xOld = this.x;
		this.yOld = this.y;
		repaint();
		this.apagou = true;

		if (!this.informations) {
			switch (action) {
			case UP:
				// cima
				this.move(x, (y - 4), 1);
				break;
			case KEY_NUM2:
				// cima
				this.move(x, (y - 4), 1);
				break;
			case DOWN:
				// baixo
				this.move(x, (y + 4), 2);
				break;
			case KEY_NUM8:
				// baixo
				this.move(x, (y + 4), 2);
				break;
			case LEFT:
				// esquerda
				this.move((x - 4), y, 3);
				break;
			case KEY_NUM4:
				// esquerda
				this.move((x - 4), y, 3);
				break;
			case RIGHT:
				// direita
				this.move((x + 4), y, 4);
				break;
			case KEY_NUM6:
				// direita
				this.move((x + 4), y, 4);
				break;
			}
			//this.paint(this.grap);
			//serviceRepaints();
			//this.repaint = true;
			this.repaint();
		}
		}
		//}

	}

	/***************************************************************************
	 * O mtodo move(int x, int y) atualiza a posicao do jogador na tela.
	 **************************************************************************/
	public void move(int x, int y, int direction) {
		try {
			if (!this.game.isScreen2()) {

				if (!this.game.colision(x / 4, y / 4, direction, this)) {
					//som do movimento permitido!
					if (this.game.getGameSettings().getSound()
							&& this.game.getTime() > 10) {

						this.moveSound();

					}
					this.x = (this.game.getXPosition() * 4);
					this.y = this.game.getYPosition() * 4;

				} else {
					//Som de batida na parede!
					if (this.game.getGameSettings().getSound()
							&& this.game.getTime() > 10) {
						//Sound s = new Sound(41,50,100);
						//Thread t = new Thread(s);
						//t.start();

						this.colisionSound();

					}
				}
			} else {

				if (x < 0) {
					x = 0;
				}
				if (!this.game.colision(((x + 128) / 4), ((y / 4)), direction,
						this)) {

					//som do movimento permitido!
					if (this.game.getGameSettings().getSound()
							&& this.game.getTime() > 10) {
						//Sound s = new Sound(30,50,75);
						//Thread t = new Thread(s);
						//t.start();
						this.moveSound();
						//s.playTone(30, 50, 75);
					}
					this.x = this.game.getXPosition() * 4;
					this.y = this.game.getYPosition() * 4;

				} else {
					//Som de batida na parede!
					if (this.game.getGameSettings().getSound()
							&& this.game.getTime() > 10) {
						//Sound s = new Sound(41,50,100);
						//Thread t = new Thread(s);
						//t.start();
						this.colisionSound();
						//s.playTone(41, 50, 100);
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		if (this.x >= 128) {
			this.x = this.x - 128;
		}

		if (this.game.winGame()) {
			this.winner();
			
		} else {
			if (this.game.winLevel()) {
				this.nextLevel();
			}
		}
		//repaint();

	}

	

	/***************************************************************************
	 * O mtodo loser()
	 **************************************************************************/
	public void loser() {

		if (this.game.getLives() == 0) {

			end = true;
			win = false;
			this.informations = true;
			
			long init = System.currentTimeMillis();
			while(System.currentTimeMillis() - init <= 2500){
				this.informations = true;
				repaint();
			}
			this.endGame();
			

		} else {
			c.cancel();
			t.cancel();
			this.game.decLives();
			this.game.setScreen2(false);
			this.game.setInitialPositions();
			this.x = game.getXPosition() * 4;
			this.y = game.getYPosition() * 4;
			this.showLevel();
			this.game.setTime(this.game.getTime() + 3);
			this.initializeCount();
			try {
				this.background = Image.createImage(this.game.getLabyrinth());
			} catch (IOException e) {

				e.printStackTrace();
			}
			Timer t = new Timer();
			PaintTimerTask pt = new PaintTimerTask();
			t.schedule(pt, 2500);
		}
	}
	
	

	/***************************************************************************
	 * O mtodo winner()
	 **************************************************************************/
	public void winner() {
		c.cancel();
		t.cancel();
		
		this.game.incScore();
		end = true;
		win = true;
		this.informations = true;
		serviceRepaints();
		long init = System.currentTimeMillis();
		while(System.currentTimeMillis() - init <= 2500){
		
		}
		
		
		RecordRegistry reg = new RecordRegistry("records");
		boolean temp = reg.isRecord(this.game.getScore());
		reg = null;
		System.gc();
		if (temp) {
			//aparece a tela de adicionar record;

			RecordsScreen rec = new RecordsScreen(this.main, this.game
					.getScore());
			//this.informations = true;
			this.main.getMain().getDisplay().setCurrent(rec);

			//reg.addRecord("nome", this.game.getScore());
		}

		this.game.getGameSettings().setOption(new Integer(0).byteValue());
		this.game.getGameSettings().write();
		this.main.initGameSettings();
		//this.main.getMain().getDisplay().setCurrent(this.main);
	}

	/***************************************************************************
	 * O mtodo playerWin() mostra a tela de jogo vencido
	 **************************************************************************/
	/*
	 * public void playerWin() { }
	 */

	/***************************************************************************
	 * O mtodo colisionSound() executa o som referente a uma colisao.
	 **************************************************************************/

	public void colisionSound() {
		sound = new SoundNokia(233, 20);
		sound.run();
		//	  	Manager.playTone(41, 50, 100);
	}

	/***************************************************************************
	 * O mtodo showLevel() mostra o level atual.
	 **************************************************************************/
	/***************************************************************************
	 * O mtodo showLevel() mostra o level atual.
	 **************************************************************************/
	public void showLevel() {
		this.informations = true;
		Timer t = new Timer();
		PaintTimerTask pt = new PaintTimerTask();
		t.schedule(pt, 2500);
	}

	/***************************************************************************
	 * O mtodo nextLevel() passa para a tela da proxima fase.
	 **************************************************************************/
	public void nextLevel() {

		c.cancel();
		t.cancel();
		Random randomNumber = new Random();

		int labNumber = Math.abs(randomNumber.nextInt()) % 3;

		this.game.incStage();

		int level = Integer.parseInt("" + this.game.getStage());
		Runtime.getRuntime().gc();

		try {
			if (level == 2) {
				switch (labNumber) {
				case 0:

					this.game.setLabyrinth(LabyrinthConstants2.LEVEL2a);
					background = Image.createImage(this.game.getLabyrinth());

					//this.game.setTime();
					break;
				case 1:
					this.game.setLabyrinth(LabyrinthConstants2.LEVEL2a);

					background = Image.createImage(this.game.getLabyrinth());
					break;
				default:

					this.game.setLabyrinth(LabyrinthConstants2.LEVEL2c);

					background = Image.createImage(this.game.getLabyrinth());
					break;
				}
			} else {
				if (level == 3) {
					switch (labNumber) {
					case 0:

						this.game.setLabyrinth(LabyrinthConstants3.LEVEL3a);

						Runtime.getRuntime().gc();

						background = Image
								.createImage(this.game.getLabyrinth());

						break;
					case 1:

						this.game.setLabyrinth(LabyrinthConstants3.LEVEL3b);

						Runtime.getRuntime().gc();

						background = Image
								.createImage(this.game.getLabyrinth());

						break;
					default:

						this.game.setLabyrinth(LabyrinthConstants3.LEVEL3c);

						Runtime.getRuntime().gc();

						background = Image
								.createImage(this.game.getLabyrinth());

						break;
					}
				}
			}
			Runtime.getRuntime().gc();
			this.withKey = false;
			this.game.incScore();
			this.game.setScreen2(false);
			this.game.initializeTimer();
			this.game.incScore();
			this.game.setInitialPositions();
			this.x = this.game.getXPosition() * 4;
			this.y = this.game.getYPosition() * 4;
			this.game.setKeyInitialPosition();
			this.game.setFindKey(false);
			this.game.setTime(this.game.getTime() + 3);
			this.initializeCount();
		} catch (IOException e) {

			e.printStackTrace();
		}
		this.win = false;
		this.end = false;
		this.showLevel();
	}

	/***************************************************************************
	 * O mtodo moveSound(boolean hit) executa ou nao o som de acordo com a
	 * variavel hit passada no parametro.
	 **************************************************************************/

	public void moveSound() {
		sound = new SoundNokia(523, 10);
		sound.run();
	}

	/***************************************************************************
	 * O mtodo endGame() finaliza o jogo.
	 **************************************************************************/

	public void saveGame() {
		this.c.cancel();
		this.t.cancel();
		this.game.getGameSettings().setMap(this.game.getLabyrinth());
		this.game.getGameSettings().setTime(this.game.getTime());
		this.game.getGameSettings().setScreen2(this.game.isScreen2());
		this.game.getGameSettings().setXPosition(this.game.getXPosition());
		this.game.getGameSettings().setYPosition(this.game.getYPosition());
		this.game.getGameSettings().setStage(this.game.getStage());		
		this.game.getGameSettings().setOption(new Integer(1).byteValue());		
		this.game.getGameSettings().setLives(
				new Integer(this.game.getLives()).byteValue());
		this.game.getGameSettings().setScore(this.game.getScore());
		this.game.getGameSettings().setFindKey(this.game.isFindKey());
		this.game.getGameSettings().setKeyX(this.game.getKeyX());
		this.game.getGameSettings().setKeyY(this.game.getKeyY());
		this.game.getGameSettings().write();
		this.main.initGameSettings();
		this.main.getMain().getDisplay().setCurrent(this.main);
	}

	public void endGame() {
		c.cancel();
		t.cancel();
		this.game.getGameSettings().setOption(new Integer(0).byteValue());
		this.game.getGameSettings().write();
		this.main.initGameSettings();
		this.main.getMain().getDisplay().setCurrent(this.main);
	}

	/**
	 * @return Returns the game.
	 */
	public Game getGame() {
		return game;
	}

	public void initializeCount() {
		t = new Timer();
		c = new Counter(this);
		t.schedule(c, 0, 1000);
	}

	public String getInitialLabyrinth() {
		Random randomNumber = new Random();

		int labNumber = Math.abs(randomNumber.nextInt()) % 3;

		String ret = LabyrinthConstants1.LEVEL1a;
		switch (labNumber) {
		case 0:

			ret = LabyrinthConstants1.LEVEL1a;
			break;
		case 1:

			ret = LabyrinthConstants1.LEVEL1b;
			break;
		default:
			ret = LabyrinthConstants1.LEVEL1b;
			//ret = LabyrinthConstants1.LEVEL1a;
			break;
		}
		return ret;
	}

	/**
	 * @return Returns the x.
	 */
	public int getX() {
		return x;
	}

	/**
	 * @param x
	 *            The x to set.
	 */
	public void setX(int x) {
		this.x = x;
	}

	/**
	 * @return Returns the xOld.
	 */
	public int getXOld() {
		return xOld;
	}

	/**
	 * @param old
	 *            The xOld to set.
	 */
	public void setXOld(int old) {
		xOld = old;
	}

	/**
	 * @return Returns the y.
	 */
	public int getY() {
		return y;
	}

	/**
	 * @param y
	 *            The y to set.
	 */
	public void setY(int y) {
		this.y = y;
	}

	/**
	 * @return Returns the yOld.
	 */
	public int getYOld() {
		return yOld;
	}

	/**
	 * @param old
	 *            The yOld to set.
	 */
	public void setYOld(int old) {
		yOld = old;
	}

	public void setBackground() {
		try {
			this.background = Image.createImage(this.game.getLabyrinth());

		} catch (IOException e) {

			e.printStackTrace();
		}
	}
	private class PaintTimerTask extends TimerTask {
		public final void run() {
			repaint();
			informations = false;
			
		}
	}


	

	

	/*
	 * public void testDecTimer(){ game.setTime(100);
	 * 
	 * this.initializeCount(); //Timer t = new Timer(); Println p = new
	 * Println(); t.schedule(p, 1000); }
	 * 
	 * private class Println extends TimerTask { public void run(){
	 * if(game.getTime() == 0){ System.out.println(true); t.cancel(); } } }
	 */
}