package labyrinth.menu;

import java.io.IOException;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

import com.nokia.mid.ui.FullCanvas;

/*
 * Classe responsvel por informar ao usurio os desenvolvedores do jogo,
 * pintando na tela o nome dos mesmos.
 */
public class CreditsScreen extends FullCanvas {

	/**
	 * Atributo que contm o MIDlet ativo do sistema.
	 */
	private LabyrinthMenu main;
	
	/**
	 * Atributo que contem uma imagem a ser impressa.
	 */
	private Image background;
	
	/**
	 * Atributo que contem a tela atual
	 */
	private boolean tela;
	
	/**
	 * Construtor que instancia um novo objeto da classe CreditsScreen.
	 */
	public CreditsScreen(LabyrinthMenu main) {
		
		
			this.main = main;	
			background = null;
			this.tela = true;
			
			repaint();		
	}
	
	/**
	 *  Metodo que captura a tecla pressionada.
	 */
	protected void keyReleased(int keyCode){
		
		switch (keyCode) {
		
		case KEY_SOFTKEY1:
			// IR P/ ABOUT
			this.tela = false;
			repaint();
			
			break;
		case KEY_SOFTKEY2:
			// IR P/ 
			if(this.tela)
				this.main.getMain().getDisplay().setCurrent(this.main);
			else {
				this.tela = true;
				repaint();
			}
			
			break;			
		default:
			
			break;
		}
	}
	
	/**
	 * Mtodo que pinta na tela as informaes dos crditos.
	 * 
	 * @param graphic
	 *            objeto que ser pintado na tela.
	 */
	protected void paint(Graphics graphics) {
		graphics.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_SMALL));
		
		//imprime um retangulo preto...
		graphics.setColor(0,0,0);
		graphics.fillRect(0, 118, 128,10);
		
		if(tela){ //IMPRIME OS CREDITOS	
			try {
				this.background = Image.createImage("/labyrinth/images/default.png");
			} catch (IOException e) {				
				e.printStackTrace();
			}
			graphics.drawImage(this.background, 0, 0, Graphics.LEFT | Graphics.TOP);
			this.background = null;
			System.gc();
			graphics.setColor(255,255,255);			
			graphics.drawString("Back", 102, 120, 0);
			graphics.drawString("About MESS", 2, 120, 0);
			
			//imprime os creditos...
			graphics.drawString("Lamberto Augusto", 64, 50, Graphics.TOP | Graphics.HCENTER );
			graphics.drawString("Milena Andrade", 64, 60, Graphics.TOP | Graphics.HCENTER );
			graphics.drawString("Onildo Ferraz", 64, 70, Graphics.TOP | Graphics.HCENTER );
			graphics.drawString("Pedro Lages", 64, 80, Graphics.TOP | Graphics.HCENTER );
			graphics.drawString("Pedro Montenegro", 64, 90, Graphics.TOP | Graphics.HCENTER );
			graphics.drawString("Williams Azevedo ", 64, 100, Graphics.TOP | Graphics.HCENTER );
			graphics.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_LARGE));
			graphics.drawString("Credits", 64, 5, Graphics.TOP | Graphics.HCENTER);
			graphics.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
			graphics.drawString("MESS Team", 64, 30, Graphics.TOP | Graphics.HCENTER);
			
		}
		
		else { //IMPRIME O ABOUT
			try {
				this.background = Image.createImage("/labyrinth/images/default.png");
			} catch (IOException e) {				
				e.printStackTrace();
			}
			graphics.drawImage(this.background, 0, 0, Graphics.LEFT | Graphics.TOP);
			this.background = null;
			System.gc();
			
			graphics.setColor(255,255,255);
			graphics.drawString("Back", 102, 120, 0);
			
			// escreve o titulo
			graphics.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_LARGE));
			graphics.drawString("About", 64, 5, Graphics.TOP | Graphics.HCENTER);	
			//			
			graphics.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_MEDIUM));
			graphics.drawString(" - MESS - ", 64, 30, Graphics.TOP | Graphics.HCENTER);
			graphics.setFont(Font.getFont(Font.FACE_MONOSPACE, Font.STYLE_PLAIN, Font.SIZE_SMALL));
			graphics.drawString("Mobile Entertainment", 64, 50, Graphics.TOP | Graphics.HCENTER);
			graphics.drawString("and", 64, 65, Graphics.TOP | Graphics.HCENTER);
			graphics.drawString(" Software Solutions ", 64, 80, Graphics.TOP | Graphics.HCENTER);
			 
	
		}		
		
	}
}