package labyrinth.records;


import java.util.Vector;

import labyrinth.settings.persistence.File;

/*
 * Cadastro dos recordes obtidos pelos usurios do jogo. Classe que gerencia a
 * adio/remoo de recordes, verificando a nova pontuao e as antigas, e se
 * as mesmas podem ou no ser adicionadas/removidas
 */
public class RecordRegistry {

	/**
	 * atributo que armazena o repositrio dos recordes.
	 */
	private RecordRepository records;

	/* MUDAR NO DIAGRAMA DE CLASSES Q ESTA ERRADO O NOME DO CONSTRUTOR******* */

	/**
	 * Construtor da classe que instancia um novo objeto.
	 */
	public RecordRegistry(String file) {
		this.records = new RecordRepository(file);
		this.initialize();
	}

	/*RETIRAR O PARAMETRO DO DIAGRAMA DE CLASSES*****/
	/**
	 * Mtodo que inicializa os recordes.
	 * 
	 * @param records
	 *            recordes que sero inicializados.
	 */
	public void initialize() {
		File rec = new File(this.records.getFileName());		
		Vector file = rec.read();		
		if (file.size() != 0) {
			int index = 0;
			while (index < file.size()) {
				this.records.getRepository().addElement(
						new Record((byte[]) file.elementAt(index)));
				index++;
			}
		}

	}

	/* NUM SERIA ESCREVER TODOS OS RECORDES AO INVES DE UM SOH?******* */
	/**
	 * Mtodo que escreve um novo recorde no repositrio.
	 * 
	 * @param name
	 *            string que representa o novo recordista.
	 * 
	 * @param record
	 *            short que contm o novo recorde do recordista.
	 */
	public void write() {
		if (this.records.getRepository().size() != 0) {
			int index = 0;
			Vector temp = new Vector();
			while (index < this.records.getRepository().size()) {				
				byte[] data = new String(((Record) this.records.getRepository()
						.elementAt(index)).getName()
						+ "#"
						+ ((Record) this.records.getRepository().elementAt(
								index)).getScore()).getBytes();
				temp.addElement(data);
				index++;
			}
			File f = new File(this.records.getFileName());			
			f.write(temp);			
		}
	}

	/**
	 * Mtodo que adiciona um novo recorde.
	 * 
	 * @param name
	 *            nome do novo recordista.
	 * 
	 * @param score
	 *            pontuao do recordista.
	 * 
	 * @return true se foi um novo recorde e false caso contrrio.
	 */
	public boolean addRecord(String name, int score) {
		boolean retorno = this.isRecord(score);
		if (name != null && name.length() < 6 && retorno) {
			this.records.addRecord(name, score);
		}
		return retorno;
	}

	/**
	 * Mtodo que retorna o atributo records.
	 * 
	 * @return Returns atributo records.
	 */
	public RecordRepository getRecords() {
		return records;
	}
	
	/**
	 * Mtodo que verifica se o recorde passado como parmetro  um novo
	 * recorde.
	 * 
	 * @param record
	 *            pontuao a verificar se  um novo recorde.
	 * 
	 * @return true se  um novo recorde ou false caso contrrio.
	 */
	public boolean isRecord(int record) {
		boolean retorno = this.records.isRecord(record);
		return retorno;
	}
	
	/**
	 * Mtodo que retorna em que ndice(em que posio) um novo recorde ser adicionado
	 * 
	 * @param score   Integer com o novo score obtido
	 * 
	 * @return		  Integer com a posio obtida com o recorde
	 */
	public int getNewRecordIndex(int score){
		return this.records.getNewRecordIndex(score);
	}
}