package labyrinth.settings;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Vector;

import labyrinth.settings.persistence.File;

public class GameSettings {

	private byte option;

	private boolean sound;

	private boolean vibracall;

	private byte level;

	private String map;

	private byte stage;

	private int x;

	private int y;

	private byte live;

	private int time;

	private int score;

	private FilePersistence file;
	
	private boolean screen2;
	
	private boolean findKey;

	private int keyX;

	private int keyY;
	
	public GameSettings() {
		this.file = new File("settings");
		this.option = Byte.parseByte("0");
		this.vibracall = true;
		this.sound = true;
		this.level = Byte.parseByte("1");
		this.stage = Byte.parseByte("1");
		this.x = 0;
		this.y = 0;
		this.live = 3;
		this.time = 0;
		this.score = 0;
		this.findKey = false;
		this.keyX = 0;
		this.keyY = 0;
		this.initialize();
	}
	

	/***************************************************************************
	 * O mtodo getOption() retorna um byte contendo o valor do atributo option.
	 **************************************************************************/
	public byte getOption() {
		return this.option;
	}

	/***************************************************************************
	 * O mtodo getSound() retorna um boolean contendo o valor do atributo
	 * sound.
	 **************************************************************************/
	public boolean getSound() {
		return this.sound;
	}

	/***************************************************************************
	 * O mtodo getVibracall() retorna um boolean contendo o valor do atributo
	 * vibracall.
	 **************************************************************************/
	public boolean getVibracall() {
		return this.vibracall;
	}

	/***************************************************************************
	 * O mtodo getLevel() retorna um byte contendo o valor do atributo level.
	 **************************************************************************/
	public byte getLevel() {
		return this.level;
	}

	/***************************************************************************
	 * O mtodo getName() retorna a String contida no atributo name.
	 **************************************************************************/
	public String getMap() {
		return this.map;
	}

	/***************************************************************************
	 * O mtodo getStage() retorna um byte contendo o valor do atributo stage.
	 **************************************************************************/
	public byte getStage() {
		return this.stage;
	}

	/***************************************************************************
	 * O mtodo getXPosition() retorna um int contendo o valor do atributo x.
	 **************************************************************************/
	public int getXPosition() {
		return this.x;
	}

	/***************************************************************************
	 * O mtodo getYPosition() retorna um int contendo o valor do atributo y.
	 **************************************************************************/
	public int getYPosition() {
		return this.y;
	}

	/***************************************************************************
	 * O mtodo getLives() retorna um int contendo o valor do atributo live.
	 **************************************************************************/
	public byte getLives() {
		return this.live;
	}

	/***************************************************************************
	 * O mtodo getTime() retorna um int contendo o valor do atributo time.
	 **************************************************************************/
	public int getTime() {
		return this.time;
	}

	/***************************************************************************
	 * O mtodo getScore() retorna um int contendo o valor do atributo score.
	 **************************************************************************/
	public int getScore() {
		return this.score;
	}

	/***************************************************************************
	 * O mtodo getName() retorna a String contida no atributo name.
	 **************************************************************************/
	/*public String getName() {
		String retorno = "";
		return retorno;
	}*/

	/** **********************OS SETS************************ */

	/***************************************************************************
	 * O mtodo setOption() atribui ao atributo option o valor da variavel
	 * passado como parmetro.Sendo este valor valido.
	 **************************************************************************/
	public void setOption(byte option) {
		this.option = option;
	}

	/***************************************************************************
	 * O mtodo setSound() atribui ao atributo sound o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setSound(boolean sound) {
		this.sound = sound;
	}

	/***************************************************************************
	 * O mtodo setVibracall() atribui ao atributo vibracall o valor da variavel
	 * passada como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setVibracall(boolean vibracall) {
		this.vibracall = vibracall;
	}

	/***************************************************************************
	 * O mtodo setLevel() atribui ao atributo level o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setLevel(byte level) {
		this.level = level;
	}

	/***************************************************************************
	 * O mtodo setMap() atribui ao atributo map o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setMap(String mapPath) {
		if (mapPath != null) {
			this.map = mapPath;
		} else {
		}
	}

	/***************************************************************************
	 * O mtodo setStage() atribui ao atributo stage o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setStage(byte stage) {
		this.stage = stage;
	}

	/***************************************************************************
	 * O mtodo setXPosition() atribui ao atributo x o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setXPosition(int x) {
		this.x = x;
	}

	/***************************************************************************
	 * O mtodo setYPosition() atribui ao atributo y o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setYPosition(int y) {
		this.y = y;
	}

	/***************************************************************************
	 * O mtodo setYPosition() atribui ao atributo y o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setLives(byte live) {
		this.live = live;
	}

	/***************************************************************************
	 * O mtodo setTime() atribui ao atributo time o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setTime(int time) {
		this.time = time;
	}

	/***************************************************************************
	 * O mtodo setScore() atribui ao atributo score o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	public void setScore(int score) {
		this.score = score;
	}

	/***************************************************************************
	 * O mtodo setName() atribui ao atributo name o valor da variavel passada
	 * como parametro.Sendo este valor valido.
	 **************************************************************************/
	/*public void setName(String name) {
	}*/

	/***************************************************************************
	 * O mtodo write() salva em arquivo as atuais configuraes do jogo.
	 **************************************************************************/

	public void write() {
		
		byte[] bytes = { option, level, stage, live };
		boolean[] booleans = { sound, vibracall, screen2, findKey };
		String strings;
		Vector v = new Vector();
		if (map != null) {
			strings = map;
		} else {
			strings = "";
		}
		int[] ints = { x, y, time, score, this.keyX, this.keyY };

		try {
			//escreve dados no byte array interno
			ByteArrayOutputStream strmBytes = new ByteArrayOutputStream();

			//escreve os tipos de dados no byte array acima
			DataOutputStream strmData = new DataOutputStream(strmBytes);
			//byte[] data;

			for (int i = 0; i < 6; i++) {
				
				if (i < 4) {					
					strmData.writeByte(bytes[i]);
					strmData.writeBoolean(booleans[i]);
				}
				if (i < 1) {
					strmData.writeUTF(strings);
				}
				strmData.writeInt(ints[i]);

				//limpar qualquer buffer de dados
				strmData.flush();

				//insere no byte array e grava no registro
				v.addElement(strmBytes.toByteArray());

				//insere qualquer dado no array interno e inicia ento a
				// escrita no inicio do array interno
				strmBytes.reset();
			}			
			this.file.write(v);

			strmBytes.close();
			strmData.close();

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	/***************************************************************************
	 * O mtodo initialize() recupera do arquivo as configuraes do jogo.
	 **************************************************************************/

	public void initialize() {
		try {
			Vector v = new Vector();
			//int t = 0;

			v = this.file.read();
			

			for (int i = 0; i < v.size(); i++) {

				ByteArrayInputStream strmBytes = new ByteArrayInputStream(
						(byte[]) v.elementAt(i));

				//l os tipos de dados Java do byte array
				DataInputStream strmData = new DataInputStream(strmBytes);

				//coloca o que leu no devido lugar
				if (i == 0) {
					this.option = strmData.readByte();
					this.sound = strmData.readBoolean();
					this.map = strmData.readUTF();
					this.x = strmData.readInt();
				} else if (i == 1) {
					this.level = strmData.readByte();
					this.vibracall = strmData.readBoolean();
					this.y = strmData.readInt();
				} else if (i == 2) {
					this.stage = strmData.readByte();
					this.screen2 = strmData.readBoolean();
					this.time = strmData.readInt();
				} else if (i == 3){
					this.live = strmData.readByte();
					this.findKey = strmData.readBoolean();
					this.score = strmData.readInt();										
				}else if (i == 4){
					this.keyX = strmData.readInt();
				}else if (i == 5){
					this.keyY = strmData.readInt();
				}
				//reinicializa
				strmBytes.reset();

				strmBytes.close();
				strmData.close();
			}
			

		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * @return Returns the screen2.
	 */
	public boolean isScreen2() {
		return screen2;
	}
	/**
	 * @param screen2 The screen2 to set.
	 */
	public void setScreen2(boolean screen2) {
		this.screen2 = screen2;
	}
	
	/**
	 * @return Returns the findKey.
	 */
	public boolean isFindKey() {
		return findKey;
	}
	/**
	 * @param findKey The findKey to set.
	 */
	public void setFindKey(boolean findKey) {
		this.findKey = findKey;
	}
	/**
	 * @return Returns the keyX.
	 */
	public int getKeyX() {
		return keyX;
	}
	/**
	 * @param keyX The keyX to set.
	 */
	public void setKeyX(int keyX) {
		this.keyX = keyX;
	}
	/**
	 * @return Returns the keyY.
	 */
	public int getKeyY() {
		return keyY;
	}
	/**
	 * @param keyY The keyY to set.
	 */
	public void setKeyY(int keyY) {
		this.keyY = keyY;
	}
}