package labyrinth.settings.persistence;

import java.util.Vector;

import javax.microedition.rms.InvalidRecordIDException;
import javax.microedition.rms.RecordEnumeration;
import javax.microedition.rms.RecordStore;
import javax.microedition.rms.RecordStoreException;
import javax.microedition.rms.RecordStoreFullException;
import javax.microedition.rms.RecordStoreNotFoundException;
import javax.microedition.rms.RecordStoreNotOpenException;

import labyrinth.settings.FilePersistence;

public class File implements FilePersistence {

	private RecordStore record;

	private String name;

	private boolean created;

	/* MODIFICAR NO DIAGRAMA DE CLASSES**** */
	public File(String file) {
		this.name = file;
		this.created = true;
	}

	/***************************************************************************
	 * O metodo open() abre um arquivo
	 **************************************************************************/
	public void open() {
		try {
			this.record = RecordStore.openRecordStore(name, created);
		} catch (RecordStoreFullException e) {
			e.printStackTrace();
			
		} catch (RecordStoreNotFoundException e) {
			e.printStackTrace();
			
		} catch (RecordStoreException e) {
			e.printStackTrace();
			
		}
	}

	/***************************************************************************
	 * O metodo close() fecha um arquivo
	 **************************************************************************/
	public void close() {
		try {
			this.record.closeRecordStore();
		} catch (RecordStoreNotOpenException e) {
			e.printStackTrace();
			
		} catch (RecordStoreException e) {
			e.printStackTrace();
			
		}
	}

	/**
	 * Mtodo q recebe um vector de array de bytes e armazena-os em um arquivo.
	 * 
	 * @param contents
	 *            Vector de array de bytes contendo o que ser armazenado.
	 */
	public void write(Vector contents) {
		
		try {			
			RecordStore.deleteRecordStore(this.name);			
			
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			int cont = 0;
			try {
				this.open();
				while (cont < contents.size()) {
					byte[] data = (byte[]) contents.elementAt(cont);
					this.record.addRecord(data, 0, data.length);
					cont++;
				}
				this.close();
			} catch (RecordStoreNotOpenException e) {
				e.printStackTrace();
				System.out
						.println("No foi possvel escrever no arquivo, pois o arquivo no foi aberto!");
			} catch (RecordStoreFullException e) {
				e.printStackTrace();
				
			} catch (RecordStoreException e) {
				e.printStackTrace();
				
			}
		}
	}
	
	/**
	 * Esse mtodo l um arquivo e retorna um vector de array de byte em cada
	 * posio, o qual poder ser manipulado da forma que queira.
	 * 
	 * @return um vector de array de byte.
	 */
	public Vector read() {
		Vector retorno = new Vector();
		try {
			this.open();
			RecordEnumeration re = this.record.enumerateRecords(null, null,
					true);
			while (re.hasPreviousElement()) {
				try {
					retorno.addElement(re.previousRecord());
				} catch (InvalidRecordIDException e1) {
					e1.printStackTrace();
					System.out.println("Erro ao ler o arquivo, ID invlida!");
				} catch (RecordStoreException e1) {
					e1.printStackTrace();
					System.out.println("Erro ao ler o arquivo!");
				}
			}
			this.close();
		} catch (RecordStoreNotOpenException e) {
			e.printStackTrace();
			System.out.println("Arquivo no encontrado!");
		}
		return retorno;
	}	
}